#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include "midi.h"
#include "modex.h"
#include "keyboard.h"

#include "classes.h"

extern unsigned char far *sprites;
extern unsigned char far *msprites;

CObject extern *first,*last;


CCoin::CCoin(int nx, int ny,int nd,unsigned delay)
{
 identity=1;
 status=2;
 score=250;
 x=nx*3; y=ny; dir=nd;
 stimer=delay; timer=0;
 fall=0; anim=1;
 animation[0]=58;
 animation[1]=59;
 animation[2]=60;
 animation[3]=59;
 animation[4]=58;
 animation[5]=59;
 animation[6]=60;
 animation[7]=59;
 animation[8]=65;
 animation[9]=66;
 animation[10]=67;
 animation[11]=68;
 animation[12]=69;
 animation[13]=69;
}

void CCoin::Draw(int page)
{
 if (!stimer && status<=2 && anim<13)
 {
  if (!dir)
  {
   putxsprite(x/3,y,page,sprites+514*(animation[anim]));
  }
  else
  {
   putxsprite(x/3,y,page,msprites+514*(animation[anim]));
  }
 }
 else
 {
  if (anim>13) anim=10;
 }
}

void CCoin::Move()
{
 Collision();
 if (stimer)
 {
  stimer--;
  if (!stimer)
   status=2;
  return;
 }
 /****************************+ Mnze bewegt sich vorwrts ***************/

 if (status==2)
 {
  timer++;
  if (timer>=5)                                    ///// Animationsschritte
  {                                                   //
   timer=0;                                           //
   anim++;                                            //
   if (anim==8)                                       //
    anim=0;                                           //
  }                                                /////
  if (!dir)
   x--;                                            ///// X-Verschiebung
  else                                                //
   x++;                                               //
						      //
  if (x>320*3)                                        //
  {                                                   //
   x-=320*3;                                          //
   y--;                                               //
  }                                                   //
  else                                                //
  if (x<0)                                            //
   x+=320*3;                                       /////

  if (VGetPixel((x/3)+18-dir*12,y+19)>=250)
   y--;
  if (VGetPixel((x/3)+18-dir*12,y+20)<250)        ///// Boden unter Fen?
  {                                                   //
   fall++;                                            // Fallbeschl.
   if (fall<15)                                       // nhern
    y++;                                              //
   else                                               //
    y+=2;                                             //
  }                                                   //
  else fall=0;                                        //
						   /////
  if ((x<=22*3 && y>165) || (x>=288*3 && y>165))
  {
    if (first==this)                                  //
    {                                                 //
     first=first->next;                               //
     first->prev=NULL;                                //
    }                                                 //
    else                                              //
     prev->next=next;                                 //
    if (next)                                         //
     next->prev=prev;                                 //
    delete this;                                      //
   return;
  }
 }
 else
 /*********************** Mnze lst sich auf ***************************/
 if (status==0)
 {
  timer++;

  x+=kpos/4;                                          // X-Verschiebung
  if (x<0)
   x+=320*3;
  y-=(jump_power-timer)>>3;                           // Y-Verschiebung

  anim=8+(timer>>2);

  if (timer>16)                                   ///// Auflsen
  {                                                   //
    Destroy();                                        //
    delete this;                                      //
    return;                                           //
  }                                                 ////
 }

}

void CCoin::Kicked(int pos)
{
 kpos=pos;
 status=0;
 timer=0;
 anim=28;
 jump_power=23;
}

void CCoin::Kill(int pos)
{
 Kicked(pos);
}

void inline CCoin::Collision()
{
 CObject *trace;
 int rx,ry,tx,ty;

 tx=x/3;
 ty=y;

 trace=first;
 while (trace)
 {
  if (trace!=this && trace->status>0 &&        //not this one and not dead?
      !stimer && !trace->stimer)
  {
   trace->GetPos(&rx,&ry);                     //Pos. abfragen

   if (rx+18>=tx && rx+14<=tx)  //Kollision links
   {
    if (abs(ry-ty)<12 && dir==0)               // mit (langsamen) Vieh
     Turn();
   }
   else
   if (tx+18>=rx && tx+14<=rx) //Kollision rechts
   {
    if (dir==1 && abs(ry-ty)<12)
     Turn();
   }
  }
  trace=trace->next;
 }
}


void inline CCoin::Destroy()
{
 if (first==this)                                  //
 {                                                 //
  first=first->next;                               //
  first->prev=NULL;                                //
 }                                                 //
						   //
 if (last==this)                                   //
 {                                                 //
  last=prev;                                       //
 }                                                 //
						   //
 if (prev)                                         //
  prev->next=next;                                 //
 if (next)                                         //
  next->prev=prev;                                 //
}