#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include "midi.h"
#include "modex.h"
#include "keyboard.h"
#include "csound.h"

#include "classes.h"

extern unsigned char far *sprites;
extern unsigned char far *msprites;
CObject extern *first;

byte const tspr[]={49,17,18,13,13};

CTurtle::~CTurtle()
{
}

CTurtle::CTurtle(int nx, int ny,int nd,unsigned delay)
{
 status=4;
 score=200;
 //lifetime=0;
 identity=2;
 x=nx*3; y=ny; dir=nd;
 stimer=delay; timer=0;
 speed=1; fall=0; anim=13;
 colors[0]=5; colors[1]=128; colors[2]=131;
}

void inline CTurtle::Draw(int page)
{
 if (!stimer)
 {
  if (!dir)
  {
   putmcsprite(x/3,y,page,colors[speed-1],sprites+514*anim);
  }
  else
  {
   putmcsprite(x/3,y,page,colors[speed-1],msprites+514*anim);
  }
 }
}

void CTurtle::Move()
{
 if (stimer)
 {
  stimer--;
  if (!stimer)
  {
   PlaySound(7);
   status=1;
  }
  return;
 }

 /***************************** Turtle lauft *****************************/

 if (status==1)
 {
  timer++;
  if (timer>=6)                                    ///// Animationsschritte
  {                                                   //
   timer=0;                                           //
   anim++;                                            //
   if (anim==17)                                      //
    anim=13;                                          //
  }                                                /////
  if (!dir)
   x-=speed;                                       ///// X-Verschiebung
  else                                                //
   x+=speed;                                          //
						      //
  if (x>320*3)                                        //
  {                                                   //
   x-=320*3;                                          //
   y--;                                               //
  }                                                   //
  else                                                //
  if (x<0)                                            //
   x+=320*3;                                       /////

  if (VGetPixel((x/3)+18-dir*12,y+19)>=250)
   y--;
  if (VGetPixel((x/3)+18-dir*12,y+20)<250)          ///// Boden unter Fen?
  {                                                   //
   fall++;                                            // Fallbeschl.
   if (fall<15)                                       // nhern
    y++;                                              //
   else                                               //
    y+=2;                                             //
  }                                                   //
  else fall=0;                                        //
						   /////

  if (x<=22*3 && y>165)                             ///// Tube
  {                                                    //
   stimer=70;                                          //
   x=8*3; y=3; dir=1;                                  //
  }                                                    //
  if (x>=288*3 && y>165)                               //
  {                                                    //
   stimer=70;                                          //
   x=280*3; y=3; dir=0;                                //
  }                                                 /////
  Collision();
 }
 else

 /************************ BETUBT *********************************/

 if (status==2)
 {
  timer++;
  if (timer<32)
  {
   x+=kpos/4;                                       ///// X-Verschiebung
   if (x>320*3)                                        //
   {                                                   //
    x-=320*3;                                          //
    y--;                                               //
   }                                                   //
   else                                                //
   if (x<0)                                            //
    x+=320*3;                                       /////
  }

  if (timer<16)                                    ////// Flug nach oben
  {                                                    //
   y-=(jump_power-timer)>>3;                           //
   if (((int)jump_power-(int)timer)<=0)                //
    fall=1;                                            //
  }                                                //////
  else
  if (timer==16)                                   ////// Flug n. unten
  anim=29;                                             //
						       //
   if (VGetPixel((x/3)+18-dir*12,y+20)<250)            //
   {                                                   //
    fall++;                                            //
    if (fall<15)                                       //
     y++;                                              //
    else                                               //
     y+=2;                                             //
   }                                                   //
   else                                                //
    fall=0;                                         /////

  if (timer<70)                                     ///// Schildkrte
  {                                                    // richtet sich
   anim=30;                                            // langsam auf
  }                                                    // und rckt
  else                                                 // Panzer zurecht...
  if (timer<800)                                       //
  {                                                    //
   if (timer%70==0)                                    //
   {                                                   //
    anim++;                                            //
    if (anim>=33)                                      //
     anim=31;                                          //
   }                                                   //
  }                                                    //
  else                                                 //
  if (timer<830)                                       //
  {                                                    //
   anim=33;                                            //
  }                                                    //
  else                                                 //
  if (timer<870)                                       //
  {                                                    //
   anim=34;                                            //
  }                                                    //
  else                                                 //
  if (timer<900)                                       //
  {                                                    //
   anim=35;                                            //
  }                                                    //
  else                                                 //
  if (timer<940)                                       //
  {                                                    //
   anim=36;                                            //
  }                                                    //
  else                                                 //
  if (timer<970)                                       //
  {                                                    //
   anim=35;                                            //
  }                                                    //
  else                                                 //
  if (timer<1082)                                      //
  {                                                    //
   anim=((timer-970)>>4)+37;                           //
  }                                                    //
  else                                             //////
  {                                                         ///// wieder 100%
   anim=13;                                                    // ok!
   timer=0;                                                    //
   status=1;                                                   //
   if (speed<3) speed++;                                       //
  }                                                         /////
 }
 else

 /************************** unsanft gewckt! *************************/

 if (status==3)
 {
  Collision();

  timer++;
  if (timer<32)
  {
   x+=kpos/4;                                       ///// X-Verschiebung
   if (x>320*3)                                        //
   {                                                   //
    x-=320*3;                                          //
    y--;                                               //
   }                                                   //
   else                                                //
   if (x<0)                                            //
    x+=320*3;                                       /////
  }

  if (timer<16)                                    ////// Flug nach oben
  {                                                    //
   y-=(jump_power-timer)>>3;                           //
   if (((int)jump_power-(int)timer)<=0)                //
    fall=1;                                            //
   return;                                             //
  }                                                //////
  else
  if (timer==16)                                   ////// Flug n. unten
   anim=13;                                            //
						       //
   if (VGetPixel((x/3)+18-dir*12,y+20)<250)            //
   {                                                   //
    fall++;                                            //
    if (fall<15)                                       //
     y++;                                              //
    else                                               //
     y+=2;                                             //
   }                                                /////
  if (timer==32)
   timer=status=1;
 }
 else
 /************************** Tote Turtle strzt ab ***********************/
 if (status==0)
 {
  timer++;
  if (timer%6==0)                                  ///// Animationsschritte
  {                                                   //
   anim++;                                            //
   if (anim==49)                                      //
    anim=46;                                          //
  }                                                /////
  if (!dir)
   x-=kpos;                                        ///// X-Verschiebung
  else                                                //
   x+=kpos;                                           //
						      //
  if (x<0)                                            //
   x+=320*3;                                       /////
						      //
						   /////
   y+=timer>>3;                                       // Y-Verschiebung
   if (y>199)
   {                                               ///// Objekt entfernen
    Destroy();                                        //
    delete this;                                      //
    return;                                           //
   }                                               /////
 }
 else
 {
  if (status==5)
  {
   timer++;
   if (timer==25)
   {
    status=1;
    //anim=13;
    //if (dir)                                          //
    // dir=0;                                           //
    //else                                              //
    // dir=1;                                           //
    Turn();
    return;
   }
   anim=49;
 }
 else
 if (status==6)                                    ///// Dreht um
 {                                                    //

  if (VGetPixel((x/3)+18-dir*12,y+19)>=250)
   y--;
  if (VGetPixel((x/3)+18-dir*12,y+20)<250)          ///// Boden unter Fen?
  {                                                   //
   fall++;                                            //  Fallbeschl.
   if (fall<15)                                       //  nhern
    y++;                                              //
   else                                               //
    y+=2;                                             //
  }                                                   //
  else fall=0;                                      ////

  timer++;                                            //
  if (timer%17==0)                                    //
  {                                                   //
   aanim++;                                           //
   if (aanim==3)                                      //
   {                                                  //
    status=1;                                         //
    anim=13;                                          //
    if (dir)                                          //
     dir=0;                                           //
    else                                              //
     dir=1;                                           //
    timer=0;                                          //
    return;                                           //
   }                                                ////
  }
  anim=tspr[aanim];
 }

 }
}

void CTurtle::Kicked(int pos)
{
 if (status==2)
 {
  status=3;
  timer=0;
  anim=29;
  jump_power=19;
 }
 else
 {
  status=2;
  kpos=pos;
  timer=0;
  anim=29;
  jump_power=23;
 }
}

void CTurtle::Kill(int pos)
{
 status=0;
 kpos=(abs(pos))>>2;
 timer=0;
 if (pos<0)
  dir=1;
 else
  dir=0;

 PlaySound(4);

 anim=46;
}

void inline CTurtle::Turn()
{
 status=6;
 timer=0;
 aanim=0;
 //anim=23;
 return;
}